#
# crash core analysis suite
#
Summary: crash utility for live systems; netdump, diskdump, kdump, LKCD or mcore dumpfiles
Name: crash
Version: 7.0.6
Release: 1.0.8%{?dist}
License: GPLv3
Group: Development/Debuggers
Source: %{name}-%{version}.tar.gz
URL: http://people.redhat.com/anderson
Distribution: Linux 2.2 or greater
Packager: Dave Anderson <anderson@redhat.com>
ExclusiveOS: Linux
ExclusiveArch: %{ix86} alpha ia64 ppc ppc64 ppc64pseries ppc64iseries x86_64 s390 s390x arm aarch64 sparc64
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: ncurses-devel zlib-devel bison snappy-devel
Requires: binutils snappy
# Patch0: crash-3.3-20.installfix.patch (patch example)
Patch101: 0001-crash-7.0.6-sparc64-changes.patch 
Patch102: 0002-crash-7.0.6-gdb-7.6-sparc64-patches.patch
Patch103: 0003-crash-7.0.6-sparc64-aligned-mem-access.patch
Patch104: 0004-A-bunch-of-fixes-for-sparc64.patch
Patch105: 0005-sparc64-support-for-3.18-kernel.patch
Patch106: 0006-sparc64-disk-dump-file-support.patch
Patch107: crash-linux-version-4.patch
Patch108: crash-vmemmap_table.patch
Patch109: sparc64-mach.patch
Patch110: sparse_cpus.patch
Patch111: crash-fix-long-multiplication.patch
Patch112: support-3.18-slab.patch
Patch113: sparc64-new-vmemmap.patch

%description
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump facilities from Red Hat Linux, the mcore kernel patch
offered by Mission Critical Linux, or the LKCD kernel patch.

%package devel
Requires: %{name} = %{version}, zlib-devel
Summary: crash utility for live systems; netdump, diskdump, kdump, LKCD or mcore dumpfiles
Group: Development/Debuggers

%description devel
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump packages from Red Hat Linux, the mcore kernel patch
offered by Mission Critical Linux, or the LKCD kernel patch.

%package extensions
Summary: Additional commands for the crash dump analysis tool
Group: Development/Debuggers

%description extensions
The extensions package contains plugins that provide additional crash
commands. The extensions can be loaded in crash via the "extend" command.

The following extensions are provided:
* eppic:  Provides C-like language for writing dump analysis scripts
* dminfo: Device-mapper target analyzer
* snap:   Takes a snapshot of live memory and creates a kdump dumpfile
* trace:  Displays kernel tracing data and traced events that occurred prior to a panic.

%prep
%setup -n %{name}-%{version}
# %patch0 -p1 -b .install (patch example)
%ifarch %{sparc}
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%endif

%build
make RPMPKG="%{version}" snappy
# make RPMPKG="%{version}-%{release}"
make extensions

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/bin
make DESTDIR=%{buildroot} install
mkdir -p %{buildroot}%{_mandir}/man8
cp crash.8 %{buildroot}%{_mandir}/man8/crash.8
mkdir -p %{buildroot}%{_includedir}/crash
cp defs.h %{buildroot}%{_includedir}/crash
mkdir -p %{buildroot}%{_libdir}/crash/extensions
if [ -f extensions/eppic.so ]
then
cp extensions/eppic.so %{buildroot}%{_libdir}/crash/extensions
fi
cp extensions/dminfo.so %{buildroot}%{_libdir}/crash/extensions
cp extensions/snap.so %{buildroot}%{_libdir}/crash/extensions
cp extensions/trace.so %{buildroot}%{_libdir}/crash/extensions

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/bin/crash
%{_mandir}/man8/crash.8*
%doc README

%files devel
%defattr(-,root,root)
%{_includedir}/*

%files extensions
%defattr(-,root,root)
%{_libdir}/crash/extensions/*

%changelog
* Mon Oct 19 2015 Dave Kleikamp <dave.kleikamp@oracle.com> 7.0.6-1.0.8
- support slab redesign for post-3.18 kernels
- support larger vmalloc/vmemmap region for post-3.18 kernels

* Tue Sep 29 2015 Srinivas Maturi <srinivas.maturi@oracle.com> 7.0.6-1.0.7
- Remove Vendor tag

* Tue Sep 01 2015 Dave Kleikamp <dave.kleikamp@oracle.com> 7.0.6-1.0.6
- 64-bit casts and type fix to allow very long bitmap

* Mon May 15 2015 Dave Kleikamp <dave.kleikamp@oracle.com> 7.0.6-1.0.5
- Implement mach command for sparc64
- Fix idle task problem caused of sparse cpu_possible_mask

* Mon Apr 15 2015 Dave Kleikamp <dave.kleikamp@oracle.com> 7.0.6-1.0.4
- Add support for linux version 4.* kernels
- Add support for 2-level vmemmap_table

* Thu Feb 26 2015 Philip Copeland <philip.copeland@oracle.com> 7.0.6-1.0.3
- Version bump for consistancy

* Mon Jan 26 2015 Dave Kleikamp <dave.kleikamp@oracle.com> 7.0.6-1.0.2.el6-bz19449352
- support uek4 kernels and crashdump support for sparc64

* Mon Jul 07 2014 Jose E. Marchesi <jose.marchesi@oracle.com> 7.0.6-1.0.2.el6
- Avoid unaligned memory loads in architectures with hard alignment
  requirements (i.e. sparc64).

* Tue Apr 15 2014 Karl Volz <karl.volz@oracle.com> 7.0.6-1.el6
- Added in sparc64 specific changes (Thanks to Bob Picco his
  help!) 
  

